﻿Type=Activity
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: False
#End Region

'Overview Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private scvOverviewScrollPosition As Int
	scvOverviewScrollPosition = 0
	Private OverviewHeight As Int
	OverviewHeight = 0
	Private StrUtil As StringUtils
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim scvOverview As ScrollView
	Dim lblOverview As Label
	lblOverview.Initialize("")
	Dim btnSpeaker As Button
	Dim btnListen As Button
	Dim btnStart As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Overview") 'Load the Overview layout file.
	ResizeViews
	scvOverview.Panel.AddView(lblOverview, _
	                          0, _
							  0, _
							  scvOverview.Width, _
							  scvOverview.Height)											 
    lblOverview.Tag = "lblInformation"
	lblOverview.Color = Colors.Black
	lblOverview.TextColor = Colors.White
	Dim m As String	
	m = "Each Country links to one or more Centres." & CRLF
	m = m & "A Centre may be, for example, a city, town or village." & CRLF
	m = m & "You will not be able to select a Centre until you have selected a Country." & CRLF & CRLF
	m = m & "After selecting a Country: select a Centre," & CRLF
	m = m & "though if there is only one Centre for the selected Country it will be automatically selected." & CRLF & CRLF
	m = m & "Each Centre links to one or more Locations." & CRLF
	m = m & "A Location may be, for example, a street or building." & CRLF
	m = m & "You will not be able to select a Location until you have selected a Centre." & CRLF & CRLF 
	m = m & "After selecting a Centre: select a Location," & CRLF
	m = m & "though if there is only one Location for the selected Centre it will be automatically selected." & CRLF & CRLF
	m = m & "Each Location links to one or more Aspects." & CRLF
	m = m & "An Aspect may be, for example, an introduction, history, building or exhibit." & CRLF & CRLF
    m = m & "After selecting a Location, press Map or View." & CRLF 
	m = m & "If 'Map' is pressed, a Google map will be displayed" & CRLF
	m = m & "showing the position of each Aspect for the selected Location and" & CRLF
	m = m & "the position of the centre of those positions." & CRLF
	m = m & "If 'View' is pressed, the following new screen is displayed for the selected Aspect:" & CRLF
	m = m & "Latitude, Longitude, Information & a Photo." & CRLF & CRLF
	m = m & "If 'Map' is pressed, a Google map will be displayed" & CRLF
	m = m & "showing the position of the selected Aspect." & CRLF
	m = m & "The Information may be scrolled vertically." & CRLF
	m = m & "The Photo may be scrolled vertically and horizontally." & CRLF 
	m = m & "Press the appropriate 'Full Screen' to display the Information / Photo in full screen mode." & CRLF
	m = m & "Press 'Listen' to listen to the Information." & CRLF
	m = m & "Press 'Speaker' to change the characteristics of the speaker when listening to the Information." & CRLF & CRLF
	m = m & "Press 'Previous' to view the previous Aspect's details for a Location." & CRLF
	m = m & "Press 'Next' to view the next Aspect's details for a Location." & CRLF
	lblOverview.Text = m
End Sub

Sub Activity_Resume
    If Main.TTS1.IsInitialized = False Then
    	Main.TTS1.Initialize("TTS1")
    End If
	ResizeViews
	lblOverview.Width = scvOverview.Width
	OverviewHeight = StrUtil.MeasureMultilineTextHeight(lblOverview, lblOverview.Text)
	lblOverview.Height = OverviewHeight
	scvOverview.Panel.Width = scvOverview.Width
	scvOverview.Panel.Height = OverviewHeight
	scvOverview.ScrollPosition = scvOverviewScrollPosition
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Main.TTS1.Release
	OverviewHeight = lblOverview.Height
	scvOverviewScrollPosition = scvOverview.ScrollPosition
End Sub

Sub TTS1_Ready(Success As Boolean)
  If Success = False Then
      Msgbox("Error initializing TTS engine.", "Speaking Overview")
  End If
End Sub

Sub btnSpeaker_Click
	StartActivity("Speaker") 'Calls the Speaker activity.
End Sub

Sub btnListen_Click
	Log("OverviewSpeaking")
	If lblOverview.Text.Length > 0 Then
        Main.TTS1.Speak(lblOverview.Text, True)
    End If
End Sub

Sub btnStart_Click
	StartActivity("Choose") 'Calls the Choose activity.	
End Sub

Sub ResizeViews
	' Technique below taken from
	' ProbCalc project
	If 100%X < 100%Y Then
		'For Portrait, sets geometry of the views.
scvOverview.SetLayout(0%X,0%Y,100%X,89.5833333333333%Y)
btnSpeaker.SetLayout(0%X,91.6666666666667%Y,31.25%X,8.33333333333333%Y)
btnListen.SetLayout(34.375%X,91.6666666666667%Y,31.25%X,8.33333333333333%Y)
btnStart.SetLayout(68.75%X,91.6666666666667%Y,31.25%X,8.33333333333333%Y)
	Else 	
		'For Landscape, sets geometry of the views.
scvOverview.SetLayout(0%X,0%Y,75%X,100%Y)
btnSpeaker.SetLayout(79.1666666666667%X,0%Y,20.8333333333333%X,12.5%Y)
btnListen.SetLayout(79.1666666666667%X,43.75%Y,20.8333333333333%X,12.5%Y)
btnStart.SetLayout(79.1666666666667%X,87.5%Y,20.8333333333333%X,12.5%Y)
	End If
End Sub
