﻿Type=Activity
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: False
#End Region

'Speaker Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim lblPitch As Label
	Dim barPitch As SeekBar
	Dim lblSpeechRate As Label
	Dim barSpeechRate As SeekBar
	Dim lblLanguage As Label
	Dim spnLanguage As Spinner
	Dim btnTest As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Speaker")   'Load the Speaker layout file
	ResizeViews
	spnLanguage.AddAll(Array As String("en", "fr", "de"))
End Sub

Sub Activity_Resume
	If Main.TTS1.IsInitialized = False Then
		For i = 0 To Activity.NumberOfViews - 1
			Activity.GetView(i).Enabled = False
		Next
		Main.TTS1.Initialize("TTS1")
	End If
	ResizeViews
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Main.TTS1.Release
End Sub

Sub TTS1_Ready (Success As Boolean)
	If Success Then
		For i = 0 To Activity.NumberOfViews - 1
			Activity.GetView(i).Enabled = True
		Next
		btnTest_Click
	Else
		Msgbox("Error initializing TTS engine.", _
		       "Setting Speech")
	End If
End Sub

Sub barSpeechRate_ValueChanged (Value As Int, UserChanged As Boolean)
	If UserChanged Then
		Main.TTS1.SpeechRate = Value / 10
	End If
End Sub

Sub barPitch_ValueChanged (Value As Int, UserChanged As Boolean)
	If UserChanged Then
		Main.TTS1.Pitch = Value / 10
	End If
End Sub
Sub spnrLanguages_ItemClick (Position As Int, Value As Object)
	If btnTest.Enabled = False Then Return
	If Main.TTS1.SetLanguage(Value, "") = False Then
		ToastMessageShow("Language data not found.", True)
		Return
	End If
End Sub

Sub btnTest_Click
	Main.TTS1.Speak("This is a test.", True)
End Sub

Sub ResizeViews
  ' Technique below taken from
	' ProbCalc project
	If 100%X < 100%Y Then 
		'For Portrait, sets geometry of the views.
lblPitch.SetLayout(6.25%X,4.16666666666667%Y,31.25%X,8.33333333333333%Y)
barPitch.SetLayout(6.25%X,12.5%Y,87.5%X,6.25%Y)
lblSpeechRate.SetLayout(6.25%X,22.9166666666667%Y,31.25%X,8.33333333333333%Y)
barSpeechRate.SetLayout(6.25%X,31.25%Y,87.5%X,6.25%Y)
lblLanguage.SetLayout(6.25%X,41.6666666666667%Y,31.25%X,8.33333333333333%Y)
spnLanguage.SetLayout(6.25%X,50%Y,87.5%X,10.4166666666667%Y)
btnTest.SetLayout(6.25%X,64.5833333333333%Y,87.5%X,20.8333333333333%Y)
	Else
		'For Landscape, sets geometry of the views.
lblPitch.SetLayout(4.16666666666667%X,6.25%Y,20.8333333333333%X,12.5%Y)
barPitch.SetLayout(4.16666666666667%X,18.75%Y,58.3333333333333%X,9.375%Y)
lblSpeechRate.SetLayout(4.16666666666667%X,34.375%Y,41.6666666666667%X,12.5%Y)
barSpeechRate.SetLayout(4.16666666666667%X,46.875%Y,58.3333333333333%X,9.375%Y)
lblLanguage.SetLayout(4.16666666666667%X,62.5%Y,20.8333333333333%X,12.5%Y)
spnLanguage.SetLayout(4.16666666666667%X,75%Y,58.3333333333333%X,15.625%Y)
btnTest.SetLayout(4.16666666666667%X,96.875%Y,58.3333333333333%X,31.25%Y)
	End If
End Sub



