﻿Type=Activity
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: False
#End Region

'View Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private btnMapEnabled As Boolean
	btnMapEnabled = False
	Private btnSpeakerEnabled As Boolean
	btnSpeakerEnabled = False
	Private btnListenEnabled As Boolean
	btnListenEnabled = False
	Private btnFullScreenInformationEnabled As Boolean
	btnFullScreenInformationEnabled = False
	Private btnFullScreenPhotoEnabled As Boolean
	btnFullScreenPhotoEnabled = False
	Private btnPreviousEnabled As Boolean
	btnPreviousEnabled = False
	Private btnNextEnabled As Boolean
	btnNextEnabled = False
    Private scvInformationScrollPosition As Int
	scvInformationScrollPosition = 0
	Private InformationHeight As Int
	InformationHeight = 0
	Private sv2dPhotoPanelWidth As Int
	sv2dPhotoPanelWidth = 0
	Private sv2dPhotoPanelHeight As Int
	sv2dPhotoPanelHeight = 0
	Private sv2dPhotoHorizontalScrollPosition As Int
	sv2dPhotoHorizontalScrollPosition = 0
	Private sv2dPhotoVerticalScrollPosition As Int
	sv2dPhotoVerticalScrollPosition = 0
	Private CursorAspect As Cursor
	Private RowNumber As Int
	Private StrUtil As StringUtils
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim lblAspect As Label
	Dim lblLocation As Label
	Dim lblCentre As Label
	Dim lblCountry As Label
	Dim lblLat As Label
	Dim lblLatitude As Label
	Dim lblLong As Label
	Dim lblLongitude As Label
	Dim scvInformation As ScrollView
	Dim lblInformation As Label
	lblInformation.Initialize("")
	Dim ivPhoto As ImageView
	Dim sv2dPhoto As ScrollView2D
	sv2dPhoto.Initialize(0, 0, "")
	Dim btnMap As Button
	Dim btnSpeaker As Button
	Dim btnListen As Button
	Dim btnFullScreenInformation As Button
	Dim btnFullScreenPhoto As Button
	Dim btnPrevious As Button
	Dim btnNext As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
    Activity.LoadLayout("View") 'Load the View layout file.
    btnMap.Enabled = False
	btnSpeaker.Enabled = False
	btnListen.Enabled = False
	btnFullScreenInformation.Enabled = False
	btnFullScreenPhoto.Enabled = False
	ResizeViews
	scvInformation.Panel.AddView(lblInformation, _
	                             0, _
								 0, _
								 scvInformation.Width, _
								 scvInformation.Height)
	lblInformation.Tag = "lblInformation"
	lblInformation.Color = Colors.Black
	lblInformation.TextColor = Colors.White
	Activity.AddView(sv2dPhoto, ivPhoto.Left, ivPhoto.Top, ivPhoto.Width, ivPhoto.Height)
	sv2dPhoto.Tag = "sv2dPhoto"
	Dim i As Int
	For i = 0 To Activity.NumberOfViews-1
		Dim v As View
		v = Activity.GetView(i)
	Next
	Dim query As String
	query = "Select Id, Aspect, Latitude, Longitude, Information, Photo " & _
	        "FROM Aspect " & _
	        "WHERE LocationId = " & Main.LocationId & " " & _
			"ORDER BY Id"
	CursorAspect = Main.SQL1.ExecQuery(query)
	If CursorAspect.RowCount = 0 Then
		lblAspect.Text="No Aspect available"
		Msgbox("No Aspect available for Location " & Main.Location & ":" & CRLF & _
		       "Select another Location.", _
			   "Invalid Location" )
		Main.Location = ""
		Main.LocationId = 0
		StartActivity("Choose") 'Calls the Choose activity.
	End If
	CursorAspect.Position = 0
	RowNumber = 0
	btnMap.Enabled = True
	btnSpeaker.Enabled = True
	btnListen.Enabled = True
	btnFullScreenInformation.Enabled = True
	btnFullScreenPhoto.Enabled = True
	btnMapEnabled = True
	btnSpeakerEnabled = True
	btnListenEnabled = True
	btnFullScreenInformationEnabled = True
	btnFullScreenPhotoEnabled = True
	DoEvents
 	SetPreviousNextButtons
	DisplayDetails
End Sub

Sub Activity_Resume
	If btnMapEnabled Then
		btnMap.Enabled = True
	Else
	    btnMap.Enabled =False
	End If
	If Main.TTS1.IsInitialized = False Then
        Main.TTS1.Initialize("TTS1")
    End If
	If btnSpeakerEnabled Then
		btnSpeaker.Enabled = True
	Else
	    btnSpeaker.Enabled =False
	End If
	If btnListenEnabled Then
		btnListen.Enabled = True
	Else
	  btnListen.Enabled =False
	End If
	If btnFullScreenInformationEnabled Then
		btnFullScreenInformation.Enabled = True
	Else
	    btnFullScreenInformation.Enabled =False
	End If
	If btnFullScreenPhotoEnabled Then
		btnFullScreenPhoto.Enabled = True
	Else
	    btnFullScreenPhoto.Enabled =False
	End If
	If btnPreviousEnabled Then
		btnPrevious.Enabled = True
	Else
	  btnPrevious.Enabled =False
	End If
	If btnNextEnabled Then
		btnNext.Enabled = True
	Else
	    btnNext.Enabled =False
	End If
	DoEvents
	ResizeViews
	lblInformation.Width = scvInformation.Width
	InformationHeight = StrUtil.MeasureMultilineTextHeight(lblInformation, lblInformation.Text)
	lblInformation.Height = InformationHeight
	scvInformation.Panel.Width = scvInformation.Width
	scvInformation.Panel.Height = InformationHeight
	scvInformation.ScrollPosition = scvInformationScrollPosition
    sv2dPhoto.HorizontalScrollPosition = sv2dPhotoHorizontalScrollPosition
	sv2dPhoto.VerticalScrollPosition = sv2dPhotoVerticalScrollPosition
	DoEvents
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	InformationHeight = lblInformation.Height
	scvInformationScrollPosition = scvInformation.ScrollPosition
	Main.TTS1.Release
	sv2dPhotoPanelWidth = sv2dPhoto.Panel.Width
	sv2dPhotoPanelHeight = sv2dPhoto.Panel.Height
	sv2dPhotoHorizontalScrollPosition = sv2dPhoto.HorizontalScrollPosition
	sv2dPhotoVerticalScrollPosition = sv2dPhoto.VerticalScrollPosition
	If btnMap.Enabled Then
		btnMapEnabled = True
	Else
	    btnMapEnabled =False
	End If
	If btnFullScreenInformation.Enabled Then
		btnFullScreenInformationEnabled = True
	Else
	    btnFullScreenInformationEnabled =False
	End If
	If btnFullScreenPhoto.Enabled Then
		btnFullScreenPhotoEnabled = True
	Else
	    btnFullScreenPhotoEnabled =False
	End If
	If btnPrevious.Enabled Then
		btnPreviousEnabled = True
	Else
	  btnPreviousEnabled =False
	End If
	If btnNext.Enabled Then
		btnNextEnabled = True
	Else
	    btnNextEnabled =False
	End If
End Sub

Sub btnMap_Click
	Dim ph As Phone
	Dim myLAN As ServerSocket
	If ph.GetDataState <> "CONNECTED" _
	And myLAN.GetMyIP = "127.0.0.1" Then
		Msgbox("Ensure that your Device" & CRLF & _
	  	       "is Data Connected by Phone" & CRLF & _
	    	   "or is WiFi Connected." & CRLF & _
	  		   "And then try again.", _
		  	   "No Internet Connection")
		Return
	End If
	Main.CentreLatitude = Main.Latitude
	Main.CentreLongitude = Main.Longitude
	Main.LatitudeList.Initialize
	Main.LongitudeList.Initialize
	Main.LatitudeList.Add(Main.Latitude)
	Main.LongitudeList.Add(Main.Longitude)
	StartActivity("Map") 'Calls the Map activity.
End Sub

Sub TTS1_Ready(Success As Boolean)
  If Success = False Then
    Msgbox("Error initializing TTS engine.", _ 
		   "Speaking Information")
  End If
End Sub

Sub btnSpeaker_Click
	StartActivity("Speaker") 'Calls the Speaker activity.
End Sub

Sub btnListen_Click
	If Main.InformationText.Length > 0 Then
        Main.TTS1.Speak(Main.InformationText, True)
    End If
End Sub

Sub btnFullScreenInformation_Click
	StartActivity("Information") 'Calls the Information activity.		
End Sub

Sub btnFullScreenPhoto_Click
	StartActivity("Photo") 'Calls the Photo activity.		
End Sub

Sub btnNext_Click
	CursorAspect.Position = CursorAspect.Position + 1
	RowNumber = CursorAspect.Position
	SetPreviousNextButtons
	DisplayDetails
End Sub

Sub btnPrevious_Click
	CursorAspect.Position = CursorAspect.Position - 1
	RowNumber = CursorAspect.Position
	SetPreviousNextButtons
	DisplayDetails
End Sub

Sub DisplayDetails
	lblCountry.Text = Main.Country
	lblCentre.Text = Main.Centre
	lblLocation.Text = Main.Location
	Main.Aspect = CursorAspect.GetString("Aspect")
	lblAspect.Text = Main.Aspect
	Main.Latitude = CursorAspect.GetDouble("Latitude")
	lblLatitude.Text = Main.Latitude
	Main.Longitude = CursorAspect.GetDouble("Longitude")
	lblLongitude.Text = Main.Longitude
	' Technique below copied from
	' LongTextSimple project
	Main.InformationText = CursorAspect.GetString("Information")
	lblInformation.Text = Main.InformationText
	' Set the lblInformation height to measured height of text
    InformationHeight = StrUtil.MeasureMultilineTextHeight(lblInformation, lblInformation.Text)
	lblInformation.Height = InformationHeight
	' Set the Information ScrollView internal Panel dimensions
	' To those of its ScrollView
	scvInformation.Panel.Width = scvInformation.Width
	scvInformation.Panel.Height = InformationHeight
	' set the scroll position to the top of the text
	' scvInformation.ScrollPosition = lblInformation.Top
    DoEvents ' needed to execute the previous line
	Dim buffer() As Byte 'declare an empty byte array
    buffer = CursorAspect.GetBlob("Photo")
    Dim inputStream1 As InputStream
    inputStream1.InitializeFromBytesArray(buffer, 0, buffer.Length)
    Main.PhotoBitmap.Initialize2(inputStream1)
    inputStream1.Close
    sv2dPhoto.Panel.Width = Main.PhotoBitmap.Width
	sv2dPhoto.Panel.Height = Main.PhotoBitmap.Height
	sv2dPhoto.Panel.SetBackgroundImage(Main.PhotoBitmap)
    sv2dPhoto.HorizontalScrollPosition = 0
	sv2dPhoto.VerticalScrollPosition = 0
End Sub

Sub ResizeViews
	' Technique below taken from
	' ProbCalc project
	If 100%X < 100%Y Then 
		'For Portrait, sets geometry of the views.
lblAspect.SetLayout(0%X,0%Y,50%X,6.25%Y)
lblLocation.SetLayout(0%X,6.25%Y,50%X,6.25%Y)
lblCentre.SetLayout(0%X,12.5%Y,50%X,6.25%Y)
lblCountry.SetLayout(0%X,18.75%Y,50%X,6.25%Y)
lblLat.SetLayout(65.625%X,0%Y,34.375%X,6.25%Y)
lblLatitude.SetLayout(65.625%X,6.25%Y,34.375%X,6.25%Y)
lblLong.SetLayout(65.625%X,12.5%Y,34.375%X,6.25%Y)
lblLongitude.SetLayout(65.625%X,18.75%Y,34.375%X,6.25%Y)
scvInformation.SetLayout(0%X,25%Y,65.625%X,41.6666666666667%Y)
btnMap.SetLayout(65.625%X,25%Y,34.375%X,10.4166666666667%Y)
btnSpeaker.SetLayout(65.625%X,35.4166666666667%Y,34.375%X,10.4166666666667%Y)
btnListen.SetLayout(65.625%X,45.8333333333333%Y,34.375%X,10.4166666666667%Y)
btnFullScreenInformation.SetLayout(65.625%X,56.25%Y,34.375%X,10.4166666666667%Y)
ivPhoto.SetLayout(0%X,66.6666666666667%Y,65.625%X,33.3333333333333%Y)
btnFullScreenPhoto.SetLayout(65.625%X,66.6666666666667%Y,34.375%X,10.4166666666667%Y)
btnPrevious.SetLayout(65.625%X,79.1666666666667%Y,34.375%X,10.4166666666667%Y)
btnNext.SetLayout(65.625%X,89.5833333333333%Y,34.375%X,10.4166666666667%Y)
    Else
	'For Landscape, sets geometry of the views.
lblAspect.SetLayout(0%X,0%Y,43.75%X,9.375%Y)
lblLocation.SetLayout(0%X,9.375%Y,43.75%X,9.375%Y)
lblCentre.SetLayout(0%X,18.75%Y,43.75%X,9.375%Y)
lblCountry.SetLayout(0%X,28.125%Y,43.75%X,9.375%Y)
lblLat.SetLayout(43.75%X,0%Y,22.9166666666667%X,9.375%Y)
lblLatitude.SetLayout(66.6666666666667%X,0%Y,33.3333333333333%X,9.375%Y)
lblLong.SetLayout(43.75%X,9.375%Y,22.9166666666667%X,9.375%Y)
lblLongitude.SetLayout(66.6666666666667%X,9.375%Y,33.3333333333333%X,9.375%Y)
scvInformation.SetLayout(43.75%X,18.75%Y,56.25%X,56.25%Y)
ivPhoto.SetLayout(0%X,37.5%Y,43.75%X,50%Y)
btnMap.SetLayout(0%X,87.5%Y,20.8333333333333%X,12.5%Y)
btnFullScreenPhoto.SetLayout(20.8333333333333%X,87.5%Y,22.9166666666667%X,12.5%Y)
btnSpeaker.SetLayout(43.75%X,75%Y,18.75%X,12.5%Y)
btnListen.SetLayout(62.5%X,75%Y,18.75%X,12.5%Y)
btnFullScreenInformation.SetLayout(81.25%X,75%Y,18.75%X,12.5%Y)
btnPrevious.SetLayout(43.75%X,87.5%Y,28.125%X,12.5%Y)
btnNext.SetLayout(71.875%X,87.5%Y,28.125%X,12.5%Y)
    End If
End Sub

Sub SetPreviousNextButtons
	If RowNumber = 0 Then
		btnPrevious.Enabled = False
		btnPreviousEnabled = False
	Else
		btnPrevious.Enabled = True
		btnPreviousEnabled = True
	End If
	If RowNumber + 1 = CursorAspect.RowCount Then
		btnNext.Enabled = False
		btnNextEnabled = False
	Else
		btnNext.Enabled = True
		btnNextEnabled = True
	End If
	DoEvents
End Sub

